<?php
/*
Plugin Name: cSupport Live Chat Button
Plugin URI: http://csupporthq.com/
Description: Adds a cSupport live chat button to your wordpress site
Author: cSupport
Version: 1.3.3
Author URI: http://csupporthq.com/
*/

// Function to build cSupport tag
function getcSupportLivechat()
{

	// Load in data
	$csupport_domain	= get_option('cSupportLivechat_data_website');
	$csupport_type		= get_option('cSupportLivechat_data_type');
	$csupport_autofill	= get_option('cSupportLivechat_data_autofill');
	$csupport_autostart	= get_option('cSupportLivechat_data_autostart');
	$csupport_margin	= get_option('cSupportLivechat_data_margin');
	$csupport_position	= get_option('cSupportLivechat_data_position');
	$csupport_bgcolor	= get_option('cSupportLivechat_data_bgcolor');

	$tag = '';

	// Async script
	$tag .= '<!--  cSupport Live Chat Plugin --><script type="text/javascript">(function(d,c){var scrs=d.getElementsByTagName("script");var scr=scrs[scrs.length-1];var e=d.createElement("script");e.async=true;e.src=("https:"==document.location.protocol?"https://":"http://")+"' . $csupport_domain . '/external/' . $csupport_type . '.js?"+scrs.length;if(typeof c=="function")if(e.addEventListener)e.addEventListener("load",c,false);else if(e.readyState)e.onreadystatechange=function(){if(this.readyState=="loaded")c();};scr.parentNode.insertBefore(e,scr);})(document,null);';

	// Add auto-fill
	if ($csupport_autofill=='true')
	{
		// Get user information
		global $current_user;
		get_currentuserinfo();

		// Add information
		$tag .= "var cs_name=\"".($current_user->user_login)."\";var cs_email=\"".($current_user->user_email)."\";";

		// Add auto start
		if ($csupport_autostart=='true')
		{
			$tag .= "var cs_autostart=true;";
		}
	}

	// Add positioning
	if ($csupport_position == 't-l' || $csupport_position == 't-r' || $csupport_position == 'b-l' || $csupport_position == 'b-r')
	{
		$tag .= 'var cs_position="' . $csupport_position . '";';
	}

	// Add margin
	error_log($csupport_margin);
	if (strlen($csupport_margin)>0 && is_numeric($csupport_margin))
	{
		if ($csupport_margin>100) $csupport_margin=100;
		elseif ($csupport_margin<-10) $csupport_margin=-10;
		$tag .= 'var cs_margin="' . intVal($csupport_margin) . 'px";';	
	}

	// Add color
	if (preg_match('/^#[a-fA-F0-9]{6}(\/#[a-fA-F0-9]{6})?$/i', $csupport_bgcolor))
	{
		$tag .= 'var cs_bgcolor="' . $csupport_bgcolor . '";';
	}

	$tag .= "</script><!--	//cSupport Live chat Plugin -->";

	return $tag;
}

// Function to add cSupport chat
function addcSupportLivechat()
{
	echo getcSupportLivechat();
}

// Add hook for attaching cSupport tag
add_action('wp_footer', 'addcSupportLivechat');

// Add uninstall/install hooks
register_activation_hook(__FILE__,'cSupportLivechat_install'); 
register_deactivation_hook( __FILE__, 'cSupportLivechat_remove' );

// Which data fields to install
function cSupportLivechat_install() {
	add_option("cSupportLivechat_data_website", '', '', 'yes');
	add_option("cSupportLivechat_data_type", '', '', 'yes');
	add_option("cSupportLivechat_data_autofill", 'true', '', 'yes');
	add_option("cSupportLivechat_data_autostart", 'false', '', 'yes');
	add_option("cSupportLivechat_data_margin", '', 'b-r', 'yes');
	add_option("cSupportLivechat_data_position", '', '', 'yes');
	add_option("cSupportLivechat_data_bgcolor", '', '', 'yes');
}

// Which data fields to remove
function cSupportLivechat_remove() {
	delete_option('cSupportLivechat_data_website');
	delete_option('cSupportLivechat_data_type');
	delete_option('cSupportLivechat_data_autofill');
	delete_option('cSupportLivechat_data_autotart');
	delete_option('cSupportLivechat_data_margin');
	delete_option('cSupportLivechat_data_position');
	delete_option('cSupportLivechat_data_bgcolor');
}

// Add admin menu
if(is_admin()){
	add_action('admin_menu', 'cSupportLivechat_admin_menu');

	function cSupportLivechat_admin_menu() {
		add_options_page('cSupport Live Chat Options', 'cSupport Options', 'administrator', 'cSupportLivechat', 'cSupportLivechat_html_page');
	}
}

// Add admin settings page
function cSupportLivechat_html_page() {

?>
<div class="wrap">
	<div id="icon-options-general" class="icon32"><br></div>
	<h2>cSupport Live Chat Options</h2>
	
	<form method="post" action="options.php">
	<?php wp_nonce_field('update-options'); ?>
	
	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="cSupportLivechat_data_website, cSupportLivechat_data_type, cSupportLivechat_data_autofill, cSupportLivechat_data_autostart, cSupportLivechat_data_margin, cSupportLivechat_data_position, cSupportLivechat_data_bgcolor " />
	
	<h3>General</h3>
	<table class="form-table">
			<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_website">Your cSupport domain:</label>
			</th>
			<td>
				http://
				<input name="cSupportLivechat_data_website" type="text" id="cSupportLivechat_data_website" value="<?php echo get_option('cSupportLivechat_data_website'); ?>" /><br />
				<span style="font-size: 8pt;"><strong>Note:</strong> Your cSupport domain is your unique address that you registered at cSupport, ie. subdomain.csupporthq.com</span>
			</td>
		</tr>

		<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_type">Type:</label>
			</th>
			<td>
				<select name="cSupportLivechat_data_type" id="cSupportLivechat_data_type">
					<option value="chat-float-inline" <?php if (get_option('cSupportLivechat_data_type') == 'chat-float-inline') {printf('selected');}?>>Floating Inline Chat Button</option>
					<option value="chat-float" <?php if (get_option('cSupportLivechat_data_type') == 'chat-float') {printf('selected');}?>>Floating Popup Chat Button</option>
				</select><br/>
				<span style="font-size: 8pt;"><strong>Help:</strong> How the button should work. Inline means that the chat will stay inside the window. Popup means that the chat will popup in a new window.</span>
			</td>
		</tr>
	
		<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_autofill">Auto-fill:</label>
			</th>
			<td>
				<input name="cSupportLivechat_data_autofill" type="checkbox" value="true" <?php if (get_option('cSupportLivechat_data_autofill') == 'true') {printf('checked="checked"');}?> id="cSupportLivechat_data_autofill" /> When users are logged in, auto-fill with their information
			</td>
		</tr>
		<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_autostart">Auto start session:</label>
			</th>
			<td>
				<input name="cSupportLivechat_data_autostart" type="checkbox" value="true" <?php if (get_option('cSupportLivechat_data_autostart') == 'true') {printf('checked="checked"');}?> id="cSupportLivechat_data_autostart" /> Auto start session. <strong>Note:</strong> Will only be used if auto-fill as been checked.
			</td>
		</tr>
		<tr>
			<th scope="row"></th>
			<td colspan="2">
				No account? Try a free 30-day trial now at <a href="http://csupporthq.com/pricing">http://csupporthq.com/pricing</a>
			</td>
		</tr>
	</table>
	
	<h3>Layout</h3>
	<table class="form-table">
		<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_position">Position:</label>
			</th>
			<td>
				<select name="cSupportLivechat_data_position" id="cSupportLivechat_data_position">
					<option value="b-r" <?php if (get_option('cSupportLivechat_data_position') == 'b-r') {printf('selected');}?>>Bottom Right</option>
					<option value="b-l" <?php if (get_option('cSupportLivechat_data_position') == 'b-l') {printf('selected');}?>>Bottom Left</option>
					<option value="t-r" <?php if (get_option('cSupportLivechat_data_position') == 't-r') {printf('selected');}?>>Top Right</option>
					<option value="t-l" <?php if (get_option('cSupportLivechat_data_position') == 't-l') {printf('selected');}?>>Top Left</option>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_margin">Margin pixels (only use a number):</label>
			</th>
			<td>
				<input name="cSupportLivechat_data_margin" type="text" id="cSupportLivechat_data_margin" value="<?php echo get_option('cSupportLivechat_data_margin'); ?>" /><br />
				<span style="font-size: 8pt;">The margin in pixels from the edge of the window to the chat button. Only use a number (without px), range from -10 to 100.</span>
			</td>
		</tr>
		<tr valign="top">
			<th scope="row">
				<label for="cSupportLivechat_data_bgcolor">Color (HEX):</label>
			</th>
			<td>
				<input name="cSupportLivechat_data_bgcolor" type="text" id="cSupportLivechat_data_bgcolor" value="<?php echo get_option('cSupportLivechat_data_bgcolor'); ?>" /><br />
				<div id="ilctabscolorpicker"></div>
<script type="text/javascript">
	jQuery(document).ready(function() {
		var colorPicker = jQuery.farbtastic("#ilctabscolorpicker",function(color){
													jQuery("#cSupportLivechat_data_bgcolor").css({'background-color':color,'color':(this.hsl[2]>0.5?'#000':'#fff')});
													jQuery("#cSupportLivechat_data_bgcolor").val(color);
												});
		if(/^(#[0-9a-fA-F]{6})$/.test(jQuery("#cSupportLivechat_data_bgcolor").val())) colorPicker.setColor(jQuery("#cSupportLivechat_data_bgcolor").val());
	});
</script>
				<span style="font-size: 8pt;">The base HEX color to use in the chat. Use a slash (/) with a second HEX color, to add a different color for offline mode.</span>
			</td>
		</tr>
	</table>
	
	<p class="submit">
		<input type="submit" id="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
	</p>
	</form>
</div>
<?php
}

// Function to add farbtastic
add_action('init', 'ilc_farbtastic_script');
function ilc_farbtastic_script(){
	wp_enqueue_style('farbtastic');
	wp_enqueue_script('farbtastic');
}
